#include <stdio.h>
#include <string.h>
#include "MullPop.h"
#include "symbols.h"


void BuildAtomicCharges()
{

	size_t length;
	int i;
	int j;
	int lim_1;
	double charge;
	double sum;
	char c[3];
	char *d;

	fprintf(fl,"\n\n");
	fprintf(fl,"**************************************************\n");
	fprintf(fl,"**              Atomic Charges                  **\n");
	fprintf(fl,"** (provided mainly to check the MullPop output **\n");
	fprintf(fl,"**         against your G98 logfile)            **\n");
	fprintf(fl,"**************************************************\n");
	fprintf(fl,"\n\n");

	for(i = 1; i <= numberOfAtoms; i++)
	{
		if(i == 1)
			lim_1 = 1;
		else
			lim_1 = lim_1 + numberOfBasisPerAtom[i - 1]; 

		length = strlen(banner[lim_1].label_2);		

		if(length == 1)
		{
			c[0] = banner[lim_1].label_2[0];
			c[1] = '\0'; 
		}
		else if(length == 2)
		{
			c[0] = banner[lim_1].label_2[0]; 
			c[1] = banner[lim_1].label_2[1]; 
			c[2] = '\0';
		}
 
		d = StringToLower(c);

		for(j = 1; j <= 92; j++)
		{
			if(strcmp(d, symbol[j]) == NULL)
			{
				charge = (double) j;
				break;
			}
		}

		if(spin == 0)
		{
			sum = 0.0;
			for(j = 1; j <= alpha; j++)
				sum = sum + 2.0 * reducedPop_a[i][j];

			fprintf(fl,"%2d %-3s %9.6lf\n", i, banner[lim_1].label_2, charge - sum);
		}
		else
		{
			sum = 0.0;
			for(j = 1; j <= alpha; j++)
				sum = sum + reducedPop_a[i][j];

			for(j = 1; j <= beta; j++)
				sum = sum + reducedPop_b[i][j];

			fprintf(fl,"%2d %-3s %9.6lf\n", i, banner[lim_1].label_2, charge - sum);
		}
	}

}
