#include <stdio.h>
#include <string.h>
#include "MullPop.h"

void BuildCoefficientsMatrix(void)
{

	int i;
	int nbasis;
	int natoms;
	double *a_s;
	double *b_s;

	nbasis = basis + 1;
	natoms = numberOfAtoms + 1;

	a_s = malloc(nbasis * nbasis * sizeof(double));

	if(a_s == NULL)
	{
		printf(" Error during memory allocation for C\n\n");
		exit(1);
	}

	coef_a = malloc(nbasis * sizeof(double *));

	if(coef_a == NULL)
	{
		printf(" Error during memory allocation for C\n\n");
		exit(1);
	}

	for(i = 0; i < nbasis; i++)
		coef_a[i] = a_s + (i * nbasis);

	if(spin == 1)
	{

		b_s = malloc(nbasis * nbasis * sizeof(double));

		if(b_s == NULL)
		{
			printf(" Error during memory allocation for C\n\n");
			exit(1);
		}
		
		coef_b = malloc(nbasis * sizeof(double *));

		if(coef_b == NULL)
		{
			printf(" Error during memory allocation for C\n\n");
			exit(1);
		}

		for(i = 0; i < nbasis; i++)
			coef_b[i] = b_s + (i * nbasis);

	}	

	banner = (struct Labels *) malloc(nbasis * sizeof(struct Labels));

	if(banner == NULL)
	{
		printf(" Error during memory allocation for banner\n\n");
		exit(1);
	}

	numberOfBasisPerAtom = malloc(natoms * sizeof(int));

	if(numberOfBasisPerAtom == NULL)
	{
		printf(" Error during memory allocation for numberOfBasisPerAtom\n\n");
		exit(1);
	}
}
