#include <stdio.h>
#include <string.h>
#include "MullPop.h"

#define COLUMNS 5


void BuildGrossPopulation()
{

	int i;
	int j;
	int k;
	int l;
	int m;
	double sum;


	fprintf(fl,"************************************************\n");
	fprintf(fl,"**    Gross MO Population in Terms of AOs     **\n");
	fprintf(fl,"************************************************\n");
	fprintf(fl,"**  Populations normalized to 1 irrespective  **\n");
	fprintf(fl,"**        of the actual MO accupations        **\n");
	fprintf(fl,"************************************************\n");
	fprintf(fl,"\n\n");

	if(spin == 1)
	{
		fprintf(fl,"************************************************\n");
		fprintf(fl,"**           Results for alpha MOs            **\n");
		fprintf(fl,"************************************************\n");
		fprintf(fl,"\n\n");
	}
	
	for(i = 1; i <= basis; i++)
	{
		for(j = 1; j <= basis; j++)
		{
			sum = 0.0;	
			for(k = 1; k <= basis; k++)
			{
				sum = sum + s[k][j] * coef_a[k][i];
			}
			grossPop_a[j][i] = coef_a[j][i] * sum;
		}
	}

	l = basis / COLUMNS;
			
	for(i = 1; i <= l; i++)
	{
		m = 1 + COLUMNS * (i - 1);
		fprintf(fl,"                     ");
		for(k = m; k <= m + 4; k++)
			fprintf(fl,"  %3d      ", k);

		fprintf(fl,"\n");

		for(j = 1; j <= basis; j++)
		{

			fprintf(fl,"%3d ", j);

			fprintf(fl,"%3s %-3s %-7s ", banner[j].label_1, banner[j].label_2, banner[j].label_3);

			for(k = m; k <= m + 4; k++)
				fprintf(fl," %9.6lf ", grossPop_a[j][k]);

			fprintf(fl,"\n");
		} 
		fprintf(fl,"\n");
	}

	if(basis > l * COLUMNS)
	{
		fprintf(fl,"                     ");
		for(k = 1 + COLUMNS * l; k <= basis; k++)
			fprintf(fl,"  %3d      ", k);

		fprintf(fl,"\n");

		for(j = 1; j <= basis; j++)
		{
			fprintf(fl,"%3d ", j);
	
			fprintf(fl,"%3s %-3s %-7s ", banner[j].label_1, banner[j].label_2, banner[j].label_3);

			for(k = 1 + COLUMNS * l; k <= basis; k++)
				fprintf(fl," %9.6lf ", grossPop_a[j][k]);

			fprintf(fl,"\n");

		} 
		fprintf(fl,"\n");
	}	

	if(spin == 1)
	{
		fprintf(fl,"\n\n");
		fprintf(fl,"************************************************\n");
		fprintf(fl,"**           Results for beta MOs             **\n");
		fprintf(fl,"************************************************\n");
		fprintf(fl,"\n\n");

		for(i = 1; i <= basis; i++)
		{

			for(j = 1; j <= basis; j++)
			{
				sum = 0.0;	
				for(k = 1; k <= basis; k++)
				{
					sum = sum + s[k][j] * coef_b[k][i];
				}
				grossPop_b[j][i] = coef_b[j][i] * sum;
			}
		}
	
		l = basis / COLUMNS;
			
		for(i = 1; i <= l; i++)
		{
			m = 1 + COLUMNS * (i - 1);
			fprintf(fl,"                     ");
			for(k = m; k <= m + 4; k++)
				fprintf(fl,"  %3d      ", k);

			fprintf(fl,"\n");

			for(j = 1; j <= basis; j++)
			{

				fprintf(fl,"%3d ", j);

				fprintf(fl,"%3s %-3s %-7s ", banner[j].label_1, banner[j].label_2, banner[j].label_3);

				for(k = m; k <= m + 4; k++)
					fprintf(fl," %9.6lf ", grossPop_b[j][k]);

				fprintf(fl,"\n");
			} 
			fprintf(fl,"\n");
		}

		if(basis > l * COLUMNS)
		{
			fprintf(fl,"                     ");
			for(k = 1 + COLUMNS * l; k <= basis; k++)
				fprintf(fl,"  %3d      ", k);

			fprintf(fl,"\n");

			for(j = 1; j <= basis; j++)
			{
				fprintf(fl,"%3d ", j);
	
				fprintf(fl,"%3s %-3s %-7s ", banner[j].label_1, banner[j].label_2, banner[j].label_3);

				for(k = 1 + COLUMNS * l; k <= basis; k++)
					fprintf(fl," %9.6lf ", grossPop_b[j][k]);

				fprintf(fl,"\n");

			} 
			fprintf(fl,"\n");
		}	

	}	
}
