#include <stdio.h>
#include <string.h>
#include "MullPop.h"

#define COLUMNS 5


void BuildReducedPopulation()
{

	int i;
	int j;
	int k;
	int l;
	int lim_1;
	int lim_2;
	int m;


	fprintf(fl,"************************************************\n");
	fprintf(fl,"**    Gross MO Population in Terms of atoms   **\n");
	fprintf(fl,"************************************************\n");
	fprintf(fl,"**  Populations normalized to 1 irrespective  **\n");
	fprintf(fl,"**        of the actual MO accupations        **\n");
	fprintf(fl,"************************************************\n");
	fprintf(fl,"\n\n");

	if(spin == 1)
	{
		fprintf(fl,"************************************************\n");
		fprintf(fl,"**           Results for alpha MOs            **\n");
		fprintf(fl,"************************************************\n");
		fprintf(fl,"\n\n");
	}
	
	for(i = 1; i <= numberOfAtoms; i++)
	{
		for(k = 1; k <= basis; k++)
			reducedPop_a[i][k] = 0.0;

		if(i == 1)
		{	
			lim_1 = 1;
			lim_2 = numberOfBasisPerAtom[1];
		}
		else
		{
			lim_1 = lim_1 + numberOfBasisPerAtom[i - 1];
			lim_2 = lim_2 + numberOfBasisPerAtom[i];
		}

		for(j = lim_1; j <= lim_2; j++)
		{
			for(k = 1; k <= basis; k++)
			{
				reducedPop_a[i][k] = reducedPop_a[i][k] + grossPop_a[j][k];
			}
		}
	}

	l = basis / COLUMNS;
			
	for(i = 1; i <= l; i++)
	{
		m = 1 + COLUMNS * (i - 1);
		fprintf(fl,"         ");
		for(k = m; k <= m + 4; k++)
			fprintf(fl,"  %3d      ", k);

		fprintf(fl,"\n");

		lim_1 = 0;

		for(j = 1; j <= numberOfAtoms; j++)
		{

			fprintf(fl,"%2d ", j);

			if(j == 1)
				lim_1 = 1;
			else
				lim_1 = lim_1 + numberOfBasisPerAtom[j - 1]; 

			fprintf(fl,"%-3s ", banner[lim_1].label_2);

			for(k = m; k <= m + 4; k++)
				fprintf(fl," %9.6lf ", reducedPop_a[j][k]);

			fprintf(fl,"\n");
		} 
		fprintf(fl,"\n");
	}

	if(basis > l * COLUMNS)
	{
		fprintf(fl,"         ");
		for(k = 1 + COLUMNS * l; k <= basis; k++)
			fprintf(fl,"  %3d      ", k);

		fprintf(fl,"\n");

		for(j = 1; j <= numberOfAtoms; j++)
		{
			fprintf(fl,"%2d ", j);

			if(j == 1)
				lim_1 = 1;
			else
				lim_1 = lim_1 + numberOfBasisPerAtom[j - 1]; 

			fprintf(fl,"%-3s ", banner[lim_1].label_2);

			for(k = 1 + COLUMNS * l; k <= basis; k++)
				fprintf(fl," %9.6lf ", reducedPop_a[j][k]);

			fprintf(fl,"\n");

		} 
		fprintf(fl,"\n");
	}	

	if(spin == 1)
	{
		fprintf(fl,"\n\n");
		fprintf(fl,"************************************************\n");
		fprintf(fl,"**           Results for beta MOs             **\n");
		fprintf(fl,"************************************************\n");
		fprintf(fl,"\n\n");

		for(i = 1; i <= numberOfAtoms; i++)
		{

			if(i == 1)
			{	
				lim_1 = 1;
				lim_2 = numberOfBasisPerAtom[1];
			}
			else
			{
				lim_1 = lim_1 + numberOfBasisPerAtom[i - 1];
				lim_2 = lim_2 + numberOfBasisPerAtom[i];
			}

			for(j = lim_1; j <= lim_2; j++)
			{
				for(k = 1; k <= basis; k++)
				{
					reducedPop_b[i][k] = reducedPop_b[i][k] + grossPop_b[j][k];
				}
			}
		}

		l = basis / COLUMNS;
			
		for(i = 1; i <= l; i++)
		{
			m = 1 + COLUMNS * (i - 1);
			fprintf(fl,"         ");
			for(k = m; k <= m + 4; k++)
				fprintf(fl,"  %3d      ", k);
	
			fprintf(fl,"\n");
	
			for(j = 1; j <= numberOfAtoms; j++)
			{

				fprintf(fl,"%2d ", j);

				if(j == 1)
					lim_1 = 1;
				else
					lim_1 = lim_1 + numberOfBasisPerAtom[j - 1]; 

				fprintf(fl,"%-3s ", banner[lim_1].label_2);

				for(k = m; k <= m + 4; k++)
					fprintf(fl," %9.6lf ", reducedPop_b[j][k]);

				fprintf(fl,"\n");
			} 
			fprintf(fl,"\n");
		}

		if(basis > l * COLUMNS)
		{
			fprintf(fl,"         ");
			for(k = 1 + COLUMNS * l; k <= basis; k++)
				fprintf(fl,"  %3d      ", k);

			fprintf(fl,"\n");

			for(j = 1; j <= numberOfAtoms; j++)
			{
				fprintf(fl,"%2d ", j);

				if(j == 1)
					lim_1 = 1;
				else
					lim_1 = lim_1 + numberOfBasisPerAtom[j - 1]; 

				fprintf(fl,"%-3s ", banner[lim_1].label_2);
	

				for(k = 1 + COLUMNS * l; k <= basis; k++)
					fprintf(fl," %9.6lf ", reducedPop_b[j][k]);

				fprintf(fl,"\n");

			} 
			fprintf(fl,"\n");
		}	

	}	
}
