#include <stdio.h>
#include <string.h>
#include "MullPop.h"

int main()
{
	void CheckG98Input(void);
	void CheckOverlapMatrix(void);
	void BuildOverlapMatrix(void);
	void ReadOverlapMatrix(void);
	void CheckCoefficients(void);
 	void BuildCoefficientsMatrix(void);
 	void ReadCoefficientsMatrix(void);
 	void BuildPopulationMatrix(void);
	void BuildGrossPopulation(void);
	void BuildReducedPopulation(void);
	void BuildAtomicCharges(void);

	if((fl = fopen("MullPop.log", "w")) == NULL)
	{
		printf("Error. File MullPop.log not generated\n");
		exit(1);
	}

	CheckG98Input();

	CheckOverlapMatrix();

	BuildOverlapMatrix();

	ReadOverlapMatrix();

	CheckCoefficients();

	BuildCoefficientsMatrix();

	ReadCoefficientsMatrix();

	BuildPopulationMatrix();

	BuildGrossPopulation();

	BuildReducedPopulation();

	BuildAtomicCharges();

	printf(" Normal termination \n");

	free(coef_a);
	free(coef_b);
	free(s);
	free(grossPop_a);	
	free(grossPop_b);	
	free(reducedPop_a);	
	free(reducedPop_b);	
	free(banner);
	free(numberOfBasisPerAtom);

	fclose(fl);

	return 0;
}
